{ Form Template - Source and Destination Choices Lists }
unit U_choose;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, TabNotBk;

type
  TF_Choose = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    TabbedNotebook1: TTabbedNotebook;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    SrcList: TListBox;
    DstList: TListBox;
    SrcLabel2: TLabel;
    DstLabel2: TLabel;
    IncludeBtn2: TSpeedButton;
    IncAllBtn2: TSpeedButton;
    ExcludeBtn2: TSpeedButton;
    ExAllBtn2: TSpeedButton;
    SrcList2: TListBox;
    DstList2: TListBox;
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExAllBtn2Click(Sender: TObject);
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    procedure IncludeBtn2Click(Sender: TObject);
    procedure IncAllBtn2Click(Sender: TObject);
    procedure ExcludeBtn2Click(Sender: TObject);
    procedure ExAllBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_Choose: TF_Choose;

implementation

{$R *.DFM}

procedure TF_Choose.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TF_Choose.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TF_Choose.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I],
      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TF_Choose.ExAllBtn2Click(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList2.Items.Count - 1 do
    SrcList2.Items.AddObject(DstList2.Items[I], DstList2.Items.Objects[I]);
  DstList2.Items.Clear;
  SetItem(DstList2, 0);
end;

procedure TF_Choose.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TF_Choose.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
end;

function TF_Choose.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TF_Choose.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TF_Choose.IncludeBtn2Click(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList2);
  MoveSelected(SrcList2, DstList2.Items);
  SetItem(SrcList2, Index);
end;

procedure TF_Choose.IncAllBtn2Click(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList2.Items.Count - 1 do
    DstList2.Items.AddObject(SrcList2.Items[I],
      SrcList2.Items.Objects[I]);
  SrcList2.Items.Clear;
  SetItem(SrcList2, 0);
end;

procedure TF_Choose.ExcludeBtn2Click(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList2);
  MoveSelected(DstList2, SrcList2.Items);
  SetItem(DstList2, Index);
end;

procedure TF_Choose.ExAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

end.
